/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TRAITS_REAL_HPP
#define GRAPH_MODEL_TRAITS_REAL_HPP 1

#include <graph_model/type_traits/is_integer.hpp>

namespace graph_model
{

  namespace traits
  {

    namespace detail
    {

      template < typename T
		 , typename = typename type_traits::is_integer_t<T>
		 >
      class real;

      template < typename T >
      struct real< T,std::false_type >
      {
	using type = T;
      };

      template < typename T >
      struct real< T,std::true_type >
      {
	using type = double;
      };

    } // namespace detail

    template < typename T >
    struct real
      : detail::real<T>
    {};

    template < typename T >
    using real_t = typename real<T>::type;

  } // namespace traits

} // namespace graph_model

#endif
