/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef GRAPH_MODEL_TYPE_TRAITS_VOID_T_HPP
#define GRAPH_MODEL_TYPE_TRAITS_VOID_T_HPP 1

namespace graph_model
{

  namespace type_traits
  {

    template < typename... Ts >
    struct make_void
    {
      using type = void;
    };

    /// \brief C++17 utility metafunction that maps a sequence of any types to the type void
    ///
    /// See http://en.cppreference.com/w/cpp/types/void_t
    ///
    template < typename... Ts > using void_t = typename make_void<Ts...>::type;

  } // namespace type_traits

} // namespace graph_model

#endif
