/*
 * Copyright (c) 2016,2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

/// \file

#ifndef SAMPLE_SPACE_VECTOR_MPL_STORAGE_HPP
#define SAMPLE_SPACE_VECTOR_MPL_STORAGE_HPP 1

#include <sample_space/vector/tag/vector.hpp>
#include <use_default.hpp>

namespace sample_space
{

  namespace vector
  {

    namespace mpl
    {
    
      template < typename Storage >
      struct storage
      {
	using type = Storage;
      };

      template <>
      struct storage< use_default<> >
      {
	using type = sample_space::vector::tag::vector;
      };

      template < typename Storage >
      using storage_t = typename storage<Storage>::type;

    } // namespace mpl

  } // namespace vector
  
} // namespace sample_space

#endif
