/*
 * Copyright (c) 2017 Brook Milligan.
 *
 * This file is part of the GraphModel Library.
 *
 *     The GraphModel Library is free software: you can redistribute
 *     it and/or modify it under the terms of the GNU Affero General
 *     Public License as published by the Free Software Foundation,
 *     either version 3 of the License, or (at your option) any later
 *     version.
 *
 *     The GraphModel Library is distributed in the hope that it will
 *     be useful, but WITHOUT ANY WARRANTY; without even the implied
 *     warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 *     PURPOSE.  See the GNU Affero General Public License for more
 *     details.
 *
 *     You should have received a copy of the GNU Affero General
 *     Public License along with the GraphModel Library.  If not, see
 *     <http://www.gnu.org/licenses/>.
 */

#define BOOST_TEST_MODULE graph_model_vertex_vertex_expression

#ifdef INCLUDE_UNIT_TEST_HEADERS
#include <boost/test/included/unit_test.hpp>
#else
#include <boost/test/unit_test.hpp>
#endif

template < typename ... T > class XXX;

#include <graph_model/vertex/vertex_expression.hpp>

#include <boost/mpl/vector.hpp>

using test_types = boost::mpl::vector<int,long,float,double>;

BOOST_AUTO_TEST_CASE_TEMPLATE(test_typedef,T,test_types)
{
  using terminal_type = graph_model::vertex::vertex_expression< boost::yap::expr_kind::terminal
								, boost::hana::tuple<T>
								>;
}

BOOST_AUTO_TEST_CASE_TEMPLATE(test_default_construction,T,test_types)
{
  using terminal_type = graph_model::vertex::vertex_expression< boost::yap::expr_kind::terminal
								, boost::hana::tuple<T>
								>;
  terminal_type terminal;
}

BOOST_AUTO_TEST_CASE_TEMPLATE(test_comparison,T,test_types)
{
  using terminal_type = graph_model::vertex::vertex_expression< boost::yap::expr_kind::terminal
								, boost::hana::tuple<T>
								>;
  terminal_type left, right;
  auto less = left < right;
  boost::yap::evaluate(less);
}
